
#define F_CPU 8000000UL
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include "lcd.h"
#include <util/delay.h>

uint16_t y,ADCvalue;



void ADC_Init(void)
{

	// Configure ADC pins (inputs and disabled pull-ups).
	DDRB &= ~((1<<PB6)|(1<<PB7));
	PORTB &= ~((1<<PB6)|(1<<PB7));

	ADMUX = (1<<REFS0) | (1<<REFS1)| (1<<REFS2) | (1<<MUX0) | (1<<MUX3) | (1<<MUX4);
	
	ADCSRA = (1<<ADEN) | (1<<ADSC) | (1<<ADIE) | (1<<ADPS0) | (1<<ADPS1) | (1<<ADPS2) | (1<<ADATE); 
	ADCSRB = 0;
	DIDR0=(1<<AREFD);
	DIDR1= (1<<ADC9D) | (1<<ADC8D);

}


void PWM_Start(void)
{
	
	TCCR1A = (1<<COM1B1)|(1<<PWM1B);
	TCCR1D = (0<<WGM11)|(0<WGM10);
   y=1023;
   TC1H = (y >> 8);
   OCR1C =(unsigned char)y;

	// Set PWM port pin to output.
	DDRB |= (1<<PB3);
	
	// Enable PLL, use full speed mode.
	PLLCSR = (0<<LSM) | (1<<PLLE);
	

	// Now wait for PLL to lock.
	do{ 
	}while((PLLCSR & (1<<PLOCK)) == 0);

	// Use PLL as clock source.
	PLLCSR |= (1<<PCKE);
	
	// CLK PCK = 64MHz / 1 = 64MHz.
	TCCR1B |= (0<<CS13)|(0<<CS12)|(1<<CS11)|(0<<CS10);
}





int main(void)
{
    char buffer[4],buffer1[4];
    uint16_t x=0;
     
   
	ADC_Init();
    PWM_Start();
	sei();
	_delay_ms(500);
    /* initialize display, cursor off */
    lcd_init(LCD_DISP_ON);
	lcd_clrscr();

    for (;;) {  
		      
	_delay_ms(500);
    _delay_ms(500);
	  
   x=x+10;
  if(x>1022)
  {
  
  x=0;
  }
    TC1H = (x >> 8);
    OCR1B =(unsigned char)x;
	
        /* convert interger into string */
        itoa( ADCvalue , buffer, 10);
		 itoa( x , buffer1, 10);
	
		
		lcd_clrscr();
	
	/************************************************/
	//Mjenjaj  samo ovo ispod zvjezdica
	/************************************************/

		lcd_gotoxy(0,0);
		lcd_puts("PWM=\n");
		lcd_gotoxy(4,0);
		lcd_puts(buffer1);
		lcd_gotoxy(0,1);
		lcd_puts("ADC=\n");
		lcd_gotoxy(4,1);
		lcd_puts(buffer);



	/************************************************/
	//Ovo ispod ne diraj
	/************************************************/
	
	//	lcd_puts("PWM=\n");
	//	lcd_gotoxy(4,0);
	//	lcd_puts(buffer1);
	//	lcd_gotoxy(0,1);
	//	lcd_puts("ADC=\n");
    //    lcd_gotoxy(4,1);
	//	lcd_puts(buffer);
		
		            
    }
}

 
 ISR(ADC_vect)
{
   ADCvalue = ADCW;
}
 
 
 
 
 
 
        
       

      
  
